stages:
  - 🐳
  - 🚀

# Build image and store it in GitLab registry
📦:
  stage: 🐳
  image:
    name: gcr.io/kaniko-project/executor:v1.9.2-debug
    entrypoint: [""]
  # Using kaniko to be able building image without docker daemon : https://github.com/GoogleContainerTools/kaniko
  script:
    - /kaniko/executor
      --context "${CI_PROJECT_DIR}"
      --dockerfile "${CI_PROJECT_DIR}/Dockerfile"
      --destination "${CI_REGISTRY_IMAGE}:${CI_COMMIT_REF_NAME}"
  rules:
    # Only build image on main branch
    - if: $CI_COMMIT_BRANCH == "main"
    # and on merge requests
    - if: $CI_PIPELINE_SOURCE == "merge_request_event"

☸️:
  image:
    name: dtzar/helm-kubectl
  stage: 🚀
  script:
    | 
      # Use kubernetes agent context
      kubectl config use-context fun_with/fun-with-gitlab/dynamic-environments:demo
      
      # Install/upgrade my helm chart
      helm upgrade ${CI_COMMIT_REF_NAME}-env ./helm/ \
       --set dockerconfig=${DOCKER_CONFIG} \
       --set pod.version=${CI_COMMIT_REF_NAME} \
       --set env=${CI_COMMIT_REF_NAME} \
       --install --create-namespace \
       -n ${CI_PROJECT_NAME}-${CI_ENVIRONMENT_SLUG} \
       --recreate-pods
  environment:
    name: $CI_COMMIT_REF_NAME
    url: https://$CI_COMMIT_REF_NAME.devoxx.yodamad.fr
    on_stop: ✋
  rules:
    # Only build image on main branch
    - if: $CI_COMMIT_BRANCH == "main"
    # and on merge requests
    - if: $CI_PIPELINE_SOURCE == "merge_request_event"

✋:
  image:
    name: dtzar/helm-kubectl
  stage: 🚀
  script:
    |
      kubectl config use-context fun_with/fun-with-gitlab/dynamic-environments:demo 

      # Delete helm chart
      helm delete ${CI_COMMIT_REF_NAME}-env -n ${CI_PROJECT_NAME}-${CI_ENVIRONMENT_SLUG}

      # Delete associated namespace
      kubectl delete namespace ${CI_PROJECT_NAME}-${CI_ENVIRONMENT_SLUG}
  environment:
    name: $CI_COMMIT_REF_NAME
    action: stop
  rules:
    - if: $CI_MERGE_REQUEST_ID
      when: manual
